/*###########################################################################################################################################################################################################################
SugaR'z Tools Dotnet FrameWork
Version 0.0.6

Script by Clment Plantec
clement.plantec@gmail.com

Huge Thanks to :
http://lonerobot.net/
http://www.paulneale.com/




Notes:
spinner 
images


changer cIcon en icon et ucIcon en cIcon



###########################################################################################################################################################################################################################*/
global sztCtlrs, sztDotnetPaint, sztControlersQuery

struct sztControlersFramework
(
	
	sztColor = dotnetclass "System.Drawing.Color",
	sztSize = dotnetclass "System.Drawing.Size",

	fn colorPreset arg =
	(
		case arg of
		(
			-- preset colors
			#black : return sztColor.Black 
			#blue : return sztColor.Blue
			#DarkBlue : return sztColor.darkBlue
			#cornflowerBlue : return sztColor.CornflowerBlue
			#Red : return sztColor.Red
			#sztBack : return sztColor.FromArgb 93 93 93
			#sztFore : return sztColor.FromArgb 200 200 200
			#wGray1 : return sztColor.FromArgb 114 114 114
			#bGray1 : return sztColor.FromArgb 83 83 83
			#wGray2 : return sztColor.FromArgb 139 139 139
			#bGray2 : return sztColor.FromArgb 108 108 108
			#wGray3 : return sztColor.FromArgb 94 94 94
			#bGray3 : return sztColor.FromArgb 63 63 63
			#wRolGray : return sztColor.FromArgb 79 79 79
			#bRolGray : return sztColor.FromArgb 67 67 67
			#wCheckBlue1 : return sztColor.FromArgb 140 174 221
			#bCheckBlue1 : return sztColor.FromArgb 82 106 140
			#wCheckBlue2 : return sztColor.FromArgb 163 190 229
			#bCheckBlue2 : return sztColor.FromArgb 124 143 172
			#borderBlue : return sztColor.FromArgb 45 60 102
			default: return undefined
		)		
	),
	
	fn form frm name xpos ypos width height = 
	(
		frm.bounds = dotNetObject "system.drawing.rectangle" xpos ypos width height
		frm.backcolor = colorPreset #sztBack
		frm.text = name
		sysPointer = dotNetObject "system.intPtr" (windows.getMaxHWND())
		maxHandle = dotNetObject "maxCustomControls.win32HandleWrapper" sysPointer
		frm.show maxHandle
			
	),
	
	fn panel pnl xpos ypos width height color:#sztBack = 
	(
		pnl.bounds = dotNetObject "system.drawing.rectangle" xPos yPos width height
		pnl.backColor = colorPreset color

	),
	
	fn dropPanel dpnl name xpos ypos width height btnheight color:#sztBack =
	(
		dpnl.bounds = dotNetObject "system.drawing.rectangle" xPos yPos width height
		dpnl.minimumSize = dotNetObject "system.drawing.size" dpnl.size.width btnheight
		dpnl.maximumSize = dpnl.size
		dpnl.backColor = colorPreset #sztBack 
		dpnl.foreColor = colorPreset color
		dpnl.name = name
		dpnl.tag = 1
		
	),

	fn button btn name xpos ypos width height = 
	(
		btn.bounds = dotNetObject "system.drawing.rectangle" xpos ypos width height
		btn.backColor = colorPreset #wGray1
		btn.foreColor = colorPreset #sztFore
		btn.text = name
		btn.imageIndex = 0
		
	),
	
	fn checkButton cbtn name xpos ypos width height checked:false cIcon:undefined ucIcon:undefined =
	(
		cbtn.bounds = dotNetObject "system.drawing.rectangle" xpos ypos width height
		cbtn.backColor = colorPreset #wGray1
		cbtn.foreColor = colorPreset #sztFore
		cbtn.text = name
		cbtn.checked = checked
		if checked then cbtn.imageIndex = 3 else cbtn.imageIndex = 0
		
		imgList = dotNetObject "System.Windows.Forms.ImageList"
		cbtn.imageList = imgList 
		if cIcon != undefined do 
		(
			if ucIcon != undefined
				then (
					for i = 0 to 2 do imgList.images.add ((dotNetClass "System.Drawing.Image").fromFile cIcon)
					for i = 3 to 4 do imgList.images.add ((dotNetClass "System.Drawing.Image").fromFile ucIcon)
				
				)
				else for i = 0 to 4 do imgList.images.add ((dotNetClass "System.Drawing.Image").fromFile cIcon)
				
		)
	),
		
	sPaint = sztDotnetPaint(),
	sQuery = sztControlersQuery()
	
)




struct sztDotnetPaint
(
	-- dotNetObject "system.drawing.rectangle"
	fn rectFn p1 p2 p3 p4 = 
	(
		local rect = dotnetobject "System.Drawing.Rectangle" p1 p2 p3 p4
		return rect
		
	),
	
	-- full color fill
	fn fillRectFn s e dColor graph = 
	(
		fillRect = sztCtlrs.sPaint.rectFn 0 0 s.width s.height
		fillBrush = dotNetObject "system.drawing.solidBrush" dColor
		
		graph.fillRectangle fillBrush fillRect
	),
	
	-- full gradient fill
	fn gradFn s e wGrey bGrey graph = 
	(
		
		gradiantRect = sztCtlrs.sPaint.rectFn 0 0 s.width s.height
		gradientMode = dotnetclass "System.Drawing.Drawing2D.LinearGradientMode"
		gradiantBrush = dotNetObject "System.Drawing.Drawing2D.LinearGradientBrush" (sztCtlrs.sPaint.rectFn 0 0 s.width s.height) (sztCtlrs.colorPreset wGrey) (sztCtlrs.colorPreset bGrey) (gradientMode.vertical)
	
		graph.fillRectangle gradiantBrush gradiantRect
	),
	
	-- trunc gradient fill
	fn truncGradFn s e dColor1 dColor2 graph = 
	(
		gradiantRect = sztCtlrs.sPaint.rectFn 0 0 s.width s.minimumSize.height
		gradientMode = dotnetclass "System.Drawing.Drawing2D.LinearGradientMode"
		gradiantBrush = dotNetObject "System.Drawing.Drawing2D.LinearGradientBrush" (sztCtlrs.sPaint.rectFn 0 0 s.width s.minimumSize.height) (sztCtlrs.colorPreset dColor1) (sztCtlrs.colorPreset dColor2) (gradientMode.vertical)
	
		graph.fillRectangle gradiantBrush gradiantRect
		
	),
	
	-- icone fill 
	fn iconeFn s e graph = 
	(
		bmpRect = sztCtlrs.sPaint.rectFn 0 0 s.width s.height
		bmpIcon = dotNetObject "System.Drawing.Bitmap" (s.imageList.images.item[s.imageIndex])
		
-- 		graph.InterpolationMode = (dotNetclass "System.Drawing.Drawing2D.InterpolationMode").HighQualityBicubic
		graph.drawImage bmpIcon bmpRect
		
	),
	
	-- full outline
	fn bordersFn s e dColor graph = 
	(
		--Objects for creating a curve. 
		curveBrush = dotNetObject "system.drawing.solidBrush" (sztCtlrs.colorPreset dColor)
		curvePen = dotNetObject "system.drawing.pen" curveBrush 1

		--Array of points for the curve to follow. 
		curveArray = dotNetObject "system.drawing.point[]" 5
		curveArray.set 0 (dotNetObject "system.drawing.point" 0 0)
		curveArray.set 1 (dotNetObject "system.drawing.point" (s.width-1) 0)
		curveArray.set 2 (dotNetObject "system.drawing.point" (s.width-1) (s.height-1))
		curveArray.set 3 (dotNetObject "system.drawing.point" 0 (s.height-1))
		curveArray.set 4 (dotNetObject "system.drawing.point" 0 0)
                        
		graph.DrawCurve curvePen curveArray 0
			
	),
	
	-- left triangle up position
	fn triUpFn s e dColor graph = 
	(
		triangleBrush = dotNetObject "system.drawing.solidBrush" (sztCtlrs.colorPreset dColor)
		triangleUpArray = dotNetObject "system.drawing.point[]" 3
		
		xPos = 10
		yPos = ((s.minimumSize.height)/ 2) - 3
			
		
		if s.tag == 1
			then 
			(
				triangleUpArray.set 0 (dotNetObject "system.drawing.point" (xPos-1) (yPos+8))
				triangleUpArray.set 1 (dotNetObject "system.drawing.point" (xPos+8) (yPos-1))
				triangleUpArray.set 2 (dotNetObject "system.drawing.point" (xPos+8) (yPos+8))
				
			)
			else 
			(
				triangleUpArray.set 0 (dotNetObject "system.drawing.point" xPos yPos)
				triangleUpArray.set 1 (dotNetObject "system.drawing.point" (xPos+8) yPos)
				triangleUpArray.set 2 (dotNetObject "system.drawing.point" (xPos+8) (yPos+8))
				
			)
		

		graph.fillPolygon triangleBrush triangleUpArray

	),
	
	-- left triangle middle Position
	fn triMidFn s e dColor graph = -- down:undefined  = 
	(
		
		triangleBrush = dotNetObject "system.drawing.solidBrush" (sztCtlrs.colorPreset dColor)
		triangleUpArray = dotNetObject "system.drawing.point[]" 3
		
		xPos = 10
		yPos = (s.Size.height / 2) - 3
		
		if s.imageIndex == 1
			then 
			(
				triangleUpArray.set 0 (dotNetObject "system.drawing.point" xPos (yPos+8))
				triangleUpArray.set 1 (dotNetObject "system.drawing.point" (xPos+8) yPos)
				triangleUpArray.set 2 (dotNetObject "system.drawing.point" (xPos+8) (yPos+8))
				
			)
			else 
			(
				triangleUpArray.set 0 (dotNetObject "system.drawing.point" xPos yPos)
				triangleUpArray.set 1 (dotNetObject "system.drawing.point" (xPos+8) yPos)
				triangleUpArray.set 2 (dotNetObject "system.drawing.point" (xPos+8) (yPos+8))
				
			)
		

		graph.fillPolygon triangleBrush triangleUpArray
		
	),
	
	fn strUpFn s e str graph = 
	(
		theStr = dotnetobject "System.String" (str as string)
		strRect = s.bounds
		strBrush = dotnetobject "System.Drawing.SolidBrush" (sztCtlrs.colorPreset #sztFore)
		strFont = dotnetobject "System.Drawing.Font" "Verdana" 8 ((dotnetclass "System.Drawing.FontStyle").regular) ((dotnetclass "System.Drawing.GraphicsUnit").Point) 0
		
		strSize = graph.measureString theStr strFont
		xPos = (s.Size.width / 2) - (strSize.width / 2)
		yPos = (s.minimumSize.height / 2) - (strSize.height / 2)
		
		graph.DrawString  theStr strFont strBrush xPos yPos
		
	),
	
	-- text middle position
	fn strMidFn s e str graph = 
	(
		theStr = dotnetobject "System.String" (str as string)
		strRect = s.bounds
		strBrush = dotnetobject "System.Drawing.SolidBrush" (sztCtlrs.colorPreset #sztFore)
		strFont = dotnetobject "System.Drawing.Font" "Verdana" 8 ((dotnetclass "System.Drawing.FontStyle").regular) ((dotnetclass "System.Drawing.GraphicsUnit").Point) 0
		
		strSize = graph.measureString theStr strFont
		xPos = (s.Size.width / 2) - (strSize.width / 2)
		yPos = (s.Size.height / 2) - (strSize.height / 2)
		
		graph.DrawString  theStr strFont strBrush xPos yPos
			
	)
	
)


struct sztControlersQuery
(
	
	fn button btn name xpos ypos width height =
	(
		sztCtlrs.button btn name xpos ypos width height
		
		fn onPaint s e =
		(
			graph = e.graphics
			
			case s.imageIndex of (
				0: sztCtlrs.sPaint.gradFn s e #wGray1 #bGray1 graph
				1: sztCtlrs.sPaint.gradFn s e #wGray2 #bGray2 graph
				2: sztCtlrs.sPaint.gradFn s e #wGray3 #bGray3 graph
				
			)
			sztCtlrs.sPaint.bordersFn s e #black graph 
			sztCtlrs.sPaint.strMidFn s e s.text graph
			
		)
		fn onMouseIn s e =
		(
			s.imageIndex = 1
			s.CreateGraphics()
			
		)
		fn onMouseOut s e =
		(
			s.imageIndex = 0
			s.CreateGraphics()
			
		)
		fn onMouseDown s e =
		(
			s.imageIndex = 2
			s.CreateGraphics()
			
		)
		fn onMouseUp s e =
		(
			s.imageIndex = 1
			s.CreateGraphics()
			
		)
		dotNet.addEventHandler btn "Paint" onPaint
		dotNet.addEventHandler btn "MouseEnter" onMouseIn
		dotNet.addEventHandler btn "MouseLeave" onMouseOut
		dotNet.addEventHandler btn "MouseDown" onMouseDown
		dotNet.addEventHandler btn "MouseUp" onMouseUp
		dotNet.setLifeTimeControl btn #dotNet	
		
	),
	
	
	fn checkButton cbtn name xpos ypos width height checked:false cIcon:undefined ucIcon:undefined =
	(
		sztCtlrs.checkButton cbtn name xpos ypos width height checked:checked cIcon:cIcon ucIcon:ucIcon
		
		fn onPaint s e =
		(
			graph = e.graphics
			
			case s.imageIndex of (
				0: 
				(
					sztCtlrs.sPaint.gradFn s e #wGray1 #bGray1 graph
					if s.imageList != undefined then sztCtlrs.sPaint.iconeFn s e graph 
					sztCtlrs.sPaint.bordersFn s e #black graph
					
				)
				
				1: 
				(
					sztCtlrs.sPaint.gradFn s e #wGray2 #bGray2 graph
					if s.imageList != undefined then sztCtlrs.sPaint.iconeFn s e graph 
					sztCtlrs.sPaint.bordersFn s e #black graph
					
				)
				
				2: 
				(
					sztCtlrs.sPaint.gradFn s e #wGray3 #bGray3 graph
					if s.imageList != undefined then sztCtlrs.sPaint.iconeFn s e graph 
					sztCtlrs.sPaint.bordersFn s e #black graph
					
				)
				
				3: 
				(
					sztCtlrs.sPaint.gradFn s e #wCheckBlue1 #bCheckBlue1 graph
					if s.imageList != undefined then sztCtlrs.sPaint.iconeFn s e graph 
					sztCtlrs.sPaint.bordersFn s e #borderBlue graph
					
				)
				
				4: 
				(
					sztCtlrs.sPaint.gradFn s e #wCheckBlue2 #bCheckBlue2 graph
					if s.imageList != undefined then sztCtlrs.sPaint.iconeFn s e graph 
					sztCtlrs.sPaint.bordersFn s e #borderBlue graph
					
				)
				
			)
			
			if s.imageList == undefined then sztCtlrs.sPaint.strMidFn s e s.text graph
			
		)
		fn onMouseIn s e =
		(
			if s.checked then s.imageIndex = 4 else s.imageIndex = 1
			s.CreateGraphics()
			
		)
		fn onMouseOut s e =
		(
			if s.checked then s.imageIndex = 3 else s.imageIndex = 0
			s.CreateGraphics()
			
		)
		fn onMouseDown s e =
		(
			s.imageIndex = 2
			s.CreateGraphics()
			
		)
		fn onMouseUp s e =
		(
			if s.checked then s.imageIndex = 4 else s.imageIndex = 1
			s.CreateGraphics()
			
		)
		dotNet.addEventHandler cbtn "Paint" onPaint
		dotNet.addEventHandler cbtn "MouseEnter" onMouseIn
		dotNet.addEventHandler cbtn "MouseLeave" onMouseOut
		dotNet.addEventHandler cbtn "MouseDown" onMouseDown
		dotNet.addEventHandler cbtn "MouseUp" onMouseUp
		dotNet.setLifeTimeControl cbtn #dotNet	
		
	),
	
	
	fn dropPanel dpnl name xpos ypos width height btnheight color:#sztBack =
	(
		sztCtlrs.dropPanel dpnl name xpos ypos width height btnheight color:color
		
		fn onPaint s e =
		(
			graph = e.graphics
			
			sztCtlrs.sPaint.fillRectFn s e s.foreColor graph 
			
			sztCtlrs.sPaint.truncGradFn s e #wRolGray #bRolGray graph
			
			case s.backColor of 
			(
				(sztCtlrs.colorPreset #cornflowerBlue) : sztCtlrs.sPaint.triUpFn s e #cornflowerBlue graph 
				(sztCtlrs.colorPreset #sztBack) : sztCtlrs.sPaint.triUpFn s e #black graph
				
			)
			sztCtlrs.sPaint.strUpFn s e s.name graph
			
		)
		fn onMouseIn s e =
		(
			s.backColor = sztCtlrs.colorPreset #cornflowerBlue
			if s.tag == 0 then s.Size = dotNetObject "system.drawing.size" 200 s.MaximumSize.Height
			s.CreateGraphics()
			
			
		)
		fn onMouseOut s e =
		(
			s.backColor = sztCtlrs.colorPreset #sztBack 
			if s.tag == 0 then s.Size = dotNetObject "system.drawing.size" 200 s.minimumSize.height
			s.CreateGraphics()
			
				
		)
		fn onMouseUp s e =
		(
			if s.tag == 0 
				then 
				(
					s.tag = 1
					s.refresh()
					s.Size = dotNetObject "system.drawing.size" 200 s.MaximumSize.Height
					
					
				)
				else 
				(
					if e.Y <= s.minimumSize.height do (
					s.tag = 0
					s.refresh()
					s.Size = dotNetObject "system.drawing.size" 200 s.minimumSize.height
						
					)
					
				)
			s.CreateGraphics()
			
		)
		fn onMouseMove s e = 
		(
			-- make sure the panel is unroll
			if s.tag == 1 
				then ( 
					if e.y > s.minimumSize.height
						then s.backColor = sztCtlrs.colorPreset #sztBack
						else s.backColor = sztCtlrs.colorPreset #cornflowerBlue
					
				s.CreateGraphics()
					
				)
				
				
			
		)
		dotNet.addEventHandler dpnl "Paint" onPaint
		dotNet.addEventHandler dpnl "MouseEnter" onMouseIn
		dotNet.addEventHandler dpnl "MouseLeave" onMouseOut
		dotNet.addEventHandler dpnl "MouseUp" onMouseUp
		dotNet.addEventHandler dpnl "MouseMove" onMouseMove
		dotNet.setLifeTimeControl dpnl #dotNet
		
		
	)
	

)

sztCtlrs = sztControlersFramework()